commit 3cb7ac6f02d35eda5d9e52834d06f50d0c929ecc
Author: Georg-Johann Lay <avr@gjlay.de>
Date:   Mon Nov 18 18:12:38 2024 +0100

    AVR: target/117659 - Fix wrong code for u24 << 16.
    
    gcc/
            PR target/117659
            * config/avr/avr.cc (avr_out_ashlpsi3) [case 16]: Use %A1 as
            input (instead of bogus %A0).
    
    (cherry picked from commit bba27015f2815a8fa6fae46a29a70644e868341c)

diff --git a/gcc/config/avr/avr.cc b/gcc/config/avr/avr.cc
index 269a22b71a2..f17438d9708 100644
--- a/gcc/config/avr/avr.cc
+++ b/gcc/config/avr/avr.cc
@@ -7851,7 +7851,7 @@ avr_out_ashlpsi3 (rtx_insn *insn, rtx *op, int *plen)
 	    int reg1 = REGNO (op[1]);
 
 	    if (reg0 + 2 != reg1)
-	      avr_asm_len ("mov %C0,%A0", op, plen, 1);
+	      avr_asm_len ("mov %C0,%A1", op, plen, 1);
 
 	    return avr_asm_len ("clr %B0"  CR_TAB
 				"clr %A0", op, plen, 2);

